#!/bin/sh
#        Kylix-Built Application Installer  version 6.1
#                                 by Haruyuki Fujimaki
APPNAME=RDsync
ext=
ICONFILE=${APPNAME}.png
InstallerDirName=Deploying_$APPNAME
INSTALLDIR=/opt/KylixApps/$APPNAME
#ENCODING=ja_JP.eucJP
echo $APPNAME | tr '[A-Z]' '[a-z]' > temp.txt
read appname < temp.txt
echo ==== Installing ${APPNAME} ====
#---- checking current directory ------
mydirname=`dirname $0`
if test "$mydirname" != ".";then
 cd $mydirname
fi
#----- asking the target directory -----
ans="n"
while test "$ans" != "y"; do
    echo "This software will be installed in '${INSTALLDIR}'"
    echo -n "Is that ok? [y/n]"    > /dev/stderr
    read ans
    if test "$ans" != "y"; then
        echo -n "Please input the target directory: " > /dev/stderr
        read INSTALLDIR
    fi
done
#----- making its fullpath informer ------
echo "#!/bin/sh" >> $appname
echo "" >> $appname
read QTLIBDIR < $HOME/.qtlibpath3
if test "$QTLIBDIR" = ""; then
    echo -n "Please input the directory where Qt library libqt.so.x.x.x) for Kylix-built application has been installed: " > /dev/stderr
    read QTLIBDIR
fi
echo export LD_LIBRARY_PATH=${QTLIBDIR} >> $appname
#echo LANG=${ENCODING}>> $appname
echo ${INSTALLDIR}/$APPNAME -ns \$*>> $appname
#----- making its desktop launcher ------
s=${APPNAME}.desktop
echo [Desktop Entry] >> $s
echo Name=${APPNAME} >> $s
echo Comment=${APPNAME} >> $s
echo Icon=${ICONFILE} >> $s
echo Exec=${appname} >> $s
echo TryExec=${appname} >> $s
echo Terminal=0 >> $s
echo Type=Application >> $s
if [ ! -d /usr/share/applnk-mdk/Office/Accessories ]; then
  echo "Categories=Application;Utility" >> $s
fi
#----- making KDE MIME register (1): /mimelnk/application/------
if test "$ext" != ""; then
  s=${appname}.desktop_1
  echo [Desktop Entry] >> $s
  echo Comment=${APPNAME} >> $s
  echo Icon=${ICONFILE} >> $s
  echo Hidden=false >> $s
  echo Patterns=*.${ext} >> $s
  echo MimeType=application/${appname} >> $s
  echo Type=MimeType >> $s
#----- making KDE MIME register (2): applnk ------
  s=${appname}.desktop_2
  echo [Desktop Entry] > $s
  echo Name=${appname} >> $s
  echo Comment=${APPNAME} >> $s
  echo Icon=${ICONFILE} >> $s
  echo Exec=${appname} >> $s
  echo Terminal=false >> $s
  echo InitialPreference=2 >> $s
  echo "MimeType=application/"${appname}";Application" >> $s
  echo Type=Application >> $s
#----- making Gnome 2.8 MIME register ------
  if test "$GNOMEDIR" = ""; then
    GNOMEDIR=/usr
  fi
  if [ -d $GNOMEDIR/share/mime ]; then
    s=x-${ext}.xml
    echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>" > $s
    echo "<mime-type xmlns=\"http://www.freedesktop.org/standards/shared-mime-info\" type=\"application/x-${ext}\">" >> $s
    echo "  <comment>${APPNAME} document</comment>"  >> $s
    echo "</mime-type>" >> $s
    s=${ext}.xml
    echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>" > $s
    echo "<mime-info xmlns=\"http://www.freedesktop.org/standards/shared-mime-info\">" >> $s
    echo "  <mime-type type=\"application/x-${ext}\">" >> $s
    echo "  <comment>${APPNAME} document</comment>"  >> $s
    echo "    <glob pattern=\"*.${ext}\"/>"  >> $s
    echo "  </mime-type>" >> $s
    echo "</mime-info>" >> $s
  else
#----- making Gnome < 2.8 MIME register ------
    s=${appname}.mime
    echo application/x-${ext} > $s
    echo "	ext: ${ext}" >> $s
    s=${appname}.keys
    echo application/x-${ext} > $s
    echo "	default_application_id=${appname}" >> $s
    echo "	category=Documents" >> $s
    echo "	description=${APPNAME} file" >> $s
    echo "	icon_filename=${APPNAME}" >> $s
    echo "	short_list_application_user_additions=${appname}" >> $s
    echo "	use_category_default=no" >> $s
    s=${appname}.applications
    echo $appname > $s
    echo "	command=${appname}" >> $s
    echo "	name=${APPNAME}" >> $s
    echo "	can_open_multiple_files=true" >> $s
    echo "	expects_uris=false" >> $s
    echo "	requires_terminal=false" >> $s
    echo "	mime_types=application/x-${ext} " >> $s
  fi
fi
#----- making its uninstaller -----
s=uninstall.sh
echo "#!/bin/sh" >> $s
echo "" >> $s
echo "echo 'uninstalling ${APPNAME} ...'" >> $s
echo "rm  -rfv    ${INSTALLDIR}" >> $s
function copy()
{
    if [ -d $2 ]; then
        cp  $1  $2
        echo "rm  -fv  ${2}/${1}" >> $s
    fi
}
# ----- implementation----------------------------------
mkdir   -p    $INSTALLDIR
mv   -fv *    $INSTALLDIR
cd $INSTALLDIR
copy  $ICONFILE  /usr/share/icons
copy  $ICONFILE  /usr/share/pixmaps
copy  $APPNAME.desktop  /usr/share/applnk/Applications
copy  $APPNAME.desktop  /usr/share/applnk/Vendor_menus/Applications/Accessories
copy  $APPNAME.desktop  /usr/share/applnk-mdk/Office/Accessories
copy  $APPNAME.desktop  /usr/share/gnome/apps/Applications
copy  $APPNAME.desktop  /var/lib/menu/kde/Applications/Accessories
copy  $APPNAME.desktop  /usr/share/applications
copy  $APPNAME.desktop  /root/Desktop
# ---- MIME ----
if test "$ext" != ""; then
  # -- KDE --
  mv  -f  ${appname}.desktop_1  ${appname}.desktop
  if test "$KDEDIR" = ""; then
    if [ -d /opt/kde3 ]; then
      # SUSE
      KDEDIR=/opt/kde3
    else
      KDEDIR=/usr
    fi
  fi
  copy  ${appname}.desktop $KDEDIR/share/mimelnk/application
  mv  -f  ${appname}.desktop_2  ${appname}.desktop
  applink=applnk
  # Red Hat & FC
  if [ -d $KDEDIR/share/applnk-redhat ]; then
    applink=applnk-redhat
  fi
  # Mandrake
  if [ -d $KDEDIR/share/applnk-mdk ]; then
    applink=applnk-mdk
  fi
  copy  ${appname}.desktop   $KDEDIR/share/${applink}/.hidden
  #-- Gnome --
  if [ -d $GNOMEDIR/share/mime ]; then
    #version 2.8
    copy  x-${ext}.xml  $GNOMEDIR/share/mime/application
    copy    ${ext}.xml  $GNOMEDIR/share/mime/packages
    echo "application/x-${ext}=${APPNAME}.desktop" >> $GNOMEDIR/share/applications/defaults.list
    echo "application/x-${ext}=${APPNAME}.desktop" >> $GNOMEDIR/share/applications/mimeinfo.cache
    update-mime-database  $GNOMEDIR/share/mime
    echo "update-mime-database  $GNOMEDIR/share/mime" >> $s
  else
    #version < 2.8
    copy  ${appname}.mime  $GNOMEDIR/share/mime-info
    copy  ${appname}.keys  $GNOMEDIR/share/mime-info
    copy  ${appname}.applications  $GNOMEDIR/share/application-registry
  fi
fi
#----copying launcher to the desktop of each user ----
ls /home -F > temp.txt
while read LINE
do
  str=/home/${LINE}Desktop
  copy  $APPNAME.desktop  $str
  if [ -f ${str}/$APPNAME.desktop ]; then
    chown --silent  ${LINE%%/*}  ${str}/$APPNAME.desktop
  fi
done < temp.txt
rm temp.txt
#--------------------------------------------------------------------------
chmod    -R    a+xw $INSTALLDIR
chmod    a+x    $appname
copy    $appname    /usr/bin
echo "echo 'Uninstalled.'" >> $s
echo "Installation has completed."
echo -n "Execute now? [y/n]"    > /dev/stderr
read ans
if test "$ans" = "y" ; then
  echo "Just a moment..."
  $appname
fi
